from application import app
from flask.ext.restful import Api, Resource
import os
from subprocess import Popen as run, PIPE
from distutils.sysconfig import get_python_lib
from autoupdate import lib_path, db_path
import re


api = Api(app)
with open(db_path, 'r') as f:
    data = f.read()


def db(query):
    query = "ID   {:s} ".format(query.upper())
    begin = data.find(query)
    end = data.find("ID   ", begin+1)
    result = data[begin:end]
    pfams = re.findall("Pfam; ([^\;]*)\;", result)
    return pfams


class QueryAPI(Resource):

    def get(self, query):
        queries = [query, query.upper(), query.capitalize(), query.lower()]

        for q in queries:
            output = db(q)
            if output:
                return {'query': q, 'output': output}
        return {'query': query, 'output': output}


api.add_resource(QueryAPI, '/api/query/<string:query>', endpoint = 'query')
